#include <linux/module.h>
#include <linux/kernel.h>
#include <rtl_fifo.h>
#include <asm/rt_irq.h>
#include <asm/rt_time.h>
#include <rtl_sched.h>
#include <asm/io.h>
#include <linux/cons.h>
#include "common.h"

#define TIMEOUT 100000
#define SKIP 10000
#define PERIOD 500

RT_TASK mytask;
RTIME min_diff;
RTIME max_diff;
RTIME expected;
struct sample samp;
int skip;

void fun(int t) {

	RTIME diff,now;

	while (1) {
		for (skip = 0; skip < SKIP; skip++) {

			now = rt_get_time();
			diff = now - expected;
			if (diff < min_diff) {
				min_diff = diff;
			}
			if (diff > max_diff) {
				max_diff = diff;
			}

			expected += PERIOD;
			rt_task_wait();
		}
		samp.min = min_diff;
		samp.max = max_diff;
                min_diff = 100; max_diff = 0;
		rtf_put(0, &samp, sizeof(samp));
	}
}


int init_module(void)
{
	RTIME now = rt_get_time();
	min_diff = 1000000000;
	max_diff = -1000000000;
        printk("Starting measurement module\n");
	rtf_create(0, 4000);

	rt_task_init(&mytask, fun, 1, 3000, 4);
	expected = now + 3000;
	rt_task_make_periodic(&mytask, expected, PERIOD);

	return 0;
}


void cleanup_module(void)
{
	rt_task_delete(&mytask);
	
	rtf_destroy(0);

}

