#ifndef __RT__SCHED__
#define __RT__SCHED__

#include <asm/rt_time.h>
#define RT_TASK_MAGIC 0x754d2774

#define RT_LOWEST_PRIORITY 1000000
#ifndef RTL_FPU
#define RTL_FPU_STRUCT 
#endif


enum {RT_TASK_READY, RT_TASK_DELAYED, RT_TASK_DORMANT,RT_TASK_ACTIVE};

struct rt_task_struct {
	int *stack; 	/* hardcoded */
	int uses_fp;	/* this one is too   */
	int magic;
	int state;
	int *stack_bottom;
	int priority;
	RTIME period;
	RTIME resume_time;
	struct rt_task_struct *next;
	RTL_FPU_STRUCT   /*if RTL_FPU is not defined this is null */
};

typedef struct rt_task_struct RT_TASK;

extern RT_TASK *rt_current;

#define rt_task_init(a,b,c,d,e) rtl_task_init(a,b,c,d,e,0)
#define rt_fptask_init(a,b,c,d,e) rtl_task_init(a,b,c,d,e,1)
extern int rtl_task_init(RT_TASK *task, void (*fn)(int data), int data, int stack_size,  int priority, int use_fpu);

extern int rt_task_delete(RT_TASK *task);
extern int rt_task_wait(void);

extern int rt_task_suspend(RT_TASK *task);
extern int rt_task_wakeup(RT_TASK *task);

extern int rt_task_make_periodic(RT_TASK *task, RTIME start_time, RTIME period);

extern inline void rt_use_fp(int flag)
{
	rt_current->uses_fp = flag;
}


#endif
